﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using System.Data.SqlClient;
using System.Web.Configuration;
using Syncfusion.JavaScript.Shared.Serializer;

namespace WebApplication2.Controllers

{
    
   
  
    public class BusinessObject
    {
        public int TaskId
        {    get; set;
        }

        public string TaskName
        {
            get;
            set;
        }

        public string StartDate
        {
            get;
            set;
        }

        public string EndDate
        {
            get;
            set;
        }

        public int Duration
        {
            get;
            set;
        }

        public int Progress
        {
            get;
            set;
        }     

        public List<BusinessObject> Children
        {
            get;
            set;
        }

        public int? ParentId
        {
            get;
            set;
        }
        public string BaselineStart
        {
            get;
            set;
        }
        public string BaselineEnd
        {
            get;
            set;
        }

    }
    public class GanttController : Controller
    {
        // GET: TreeGrid
        public ActionResult Index()
        {

            
           
            return View();
        }    
       
        
        

        private List<BusinessObject> GetDesignDataSource()
        {
            List<BusinessObject> list = new List<BusinessObject>();
            var x = 0;
            for (var i = 0; i < 5; i++)
            {
                list.Add(new BusinessObject()
                {
                    TaskId = ++x,
                    TaskName = "Task" + (i + 1),
                    Progress = 50,
                    StartDate = "01/17/2010",
                    Duration = 10,
                    BaselineStart="01/17/2010",
                    BaselineEnd="01/20/2010",
                    Children = (new List<BusinessObject>()
                        {
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 1",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 10,
                                BaselineStart="01/17/2010",
                                BaselineEnd="01/20/2010",
                            },
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 2",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 10,
                                BaselineStart="01/17/2010",
                                BaselineEnd="01/20/2010",
                            },
                            new BusinessObject()
                            {
                                TaskId = ++x,
                                TaskName = "Child Task 3",
                                Progress = 50,
                                StartDate = "01/17/2010",
                                Duration = 10,
                                BaselineStart="01/17/2010",
                                BaselineEnd="01/20/2010",
                            }
                        })

                });

            }


            return list;
        }

      
        public class DMSerial : IDataSourceSerializer
        {

            public string Serialize(object obj)
            {   
                var str = Newtonsoft.Json.JsonConvert.SerializeObject(obj);
                return str;
            }
        }

        [HttpGet]
        public ActionResult _Gantt()
        {
            var DataSource = this.GetDesignDataSource();
            ViewBag.datasource = DataSource;           
            DataManagerConverter.Serializer = new DMSerial();
            return PartialView("Gantt", DataSource);
           
        }
        }
    }
